> For the complete documentation index, see [llms.txt](https://docs.ionos.com/cloud/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ionos.com/cloud/api-reference/network-services/vpn-gateway/wireguard-gateways/retrieve-wireguardgateway.md).

# Retrieve WireguardGateway

Returns the WireguardGateway by ID.

```json
{"openapi":"3.0.3","info":{"title":"IONOS CLOUD VPN Gateway API","version":"1.0.0"},"tags":[{"name":"WireguardGateways","description":"Operations to create and manage WireGuard VPN Gateways.\nThis tag groups all operations for wireguardgateways.\n"}],"servers":[{"url":"https://vpn.de-fra.ionos.com","description":"service endpoint for location de-fra"},{"url":"https://vpn.de-txl.ionos.com","description":"service endpoint for location de-txl"},{"url":"https://vpn.es-vit.ionos.com","description":"service endpoint for location es-vit"},{"url":"https://vpn.gb-bhx.ionos.com","description":"service endpoint for location gb-bhx"},{"url":"https://vpn.gb-lhr.ionos.com","description":"service endpoint for location gb-lhr"},{"url":"https://vpn.us-ewr.ionos.com","description":"service endpoint for location us-ewr"},{"url":"https://vpn.us-las.ionos.com","description":"service endpoint for location us-las"},{"url":"https://vpn.us-mci.ionos.com","description":"service endpoint for location us-mci"},{"url":"https://vpn.fr-par.ionos.com","description":"service endpoint for location fr-par"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"schemas":{"WireguardGatewayRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the WireguardGateway.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["wireguardgateway"]},"href":{"description":"The URL of the WireguardGateway.","type":"string"},"metadata":{"$ref":"#/components/schemas/WireguardGatewayMetadata"},"properties":{"$ref":"#/components/schemas/WireguardGateway"}}},"WireguardGatewayMetadata":{"description":"WireGuard Gateway Metadata","readOnly":true,"allOf":[{"$ref":"#/components/schemas/Metadata"},{"$ref":"#/components/schemas/ResourceStatus"},{"type":"object","required":["publicKey"],"properties":{"publicKey":{"type":"string","description":"Public key correspondng to the WireGuard Server private key.\n"}}}]},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"ResourceStatus":{"type":"object","description":"The current status of the resource.","required":["status"],"properties":{"status":{"$ref":"#/components/schemas/Status"},"statusMessage":{"$ref":"#/components/schemas/StatusMessage"}}},"Status":{"type":"string","description":"The current status of the resource. The status can be:\n\n* `AVAILABLE` - resource exists and is healthy.\n* `PROVISIONING` - resource is being created or updated.\n* `DESTROYING` - delete command was issued, the resource is being deleted.\n* `FAILED`: - resource failed, details in `statusMessage`.\n","readOnly":true},"StatusMessage":{"type":"string","description":"The message of the failure if the status is `FAILED`.\n","readOnly":true},"WireguardGateway":{"description":"Properties with all data needed to create a new WireGuard Gateway.\n","required":["name","gatewayIP","connections","privateKey"],"type":"object","properties":{"name":{"type":"string","description":"The human readable name of your WireguardGateway.","maxLength":255},"description":{"type":"string","description":"Human readable description of the WireguardGateway.","maxLength":1024},"gatewayIP":{"$ref":"#/components/schemas/GatewayIP"},"interfaceIPv4CIDR":{"description":"The IPV4 address (with CIDR mask) to be assigned to the WireGuard interface.\n__Note__: either interfaceIPv4CIDR or interfaceIPv6CIDR is __required__.\n","allOf":[{"$ref":"#/components/schemas/IPV4CIDR"}]},"interfaceIPv6CIDR":{"description":"The IPV6 address (with CIDR mask) to be assigned to the WireGuard interface.\n__Note__: either interfaceIPv6CIDR or interfaceIPv4CIDR is __required__.\n","allOf":[{"$ref":"#/components/schemas/IPV6CIDR"}]},"connections":{"type":"array","minItems":1,"description":"The network connection for your gateway.\n__Note__: all connections must belong to the same datacenterId. There is a limit to the total number of connections. Please refer to product documentation.\n","items":{"$ref":"#/components/schemas/Connection"}},"privateKey":{"type":"string","writeOnly":true,"description":"PrivateKey used for WireGuard Server\n"},"listenPort":{"description":"Port that WireGuard Server will listen on","default":51820,"allOf":[{"$ref":"#/components/schemas/IPPort"}]},"tier":{"$ref":"#/components/schemas/Tier"},"maintenanceWindow":{"$ref":"#/components/schemas/MaintenanceWindow"}}},"GatewayIP":{"type":"string","anyOf":[{"format":"ipv4"}],"description":"Public IP address to be assigned to the gateway.\n__Note__: This must be an IP address in the same datacenter as the connections.\n"},"IPV4CIDR":{"type":"string","pattern":"^((([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))\\/([0-9]|[1-2][0-9]|3[0-2])$","description":"Describes a range of IP V4 addresses in CIDR notation.\n"},"IPV6CIDR":{"type":"string","pattern":"^(([0-9a-fA-F]{1,4}:){7,7}[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,7}:|([0-9a-fA-F]{1,4}:){1,6}:[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,5}(:[0-9a-fA-F]{1,4}){1,2}|([0-9a-fA-F]{1,4}:){1,4}(:[0-9a-fA-F]{1,4}){1,3}|([0-9a-fA-F]{1,4}:){1,3}(:[0-9a-fA-F]{1,4}){1,4}|([0-9a-fA-F]{1,4}:){1,2}(:[0-9a-fA-F]{1,4}){1,5}|[0-9a-fA-F]{1,4}:((:[0-9a-fA-F]{1,4}){1,6})|:((:[0-9a-fA-F]{1,4}){1,7}|:))\\/([0-9]|[0-9][0-9]|1[0-1][0-9]|12[0-8])$","description":"Describes a range of IP V6 addresses in CIDR notation.\n"},"Connection":{"description":"Details about the network connection for your VPN Gateway.","required":["datacenterId","lanId","ipv4CIDR"],"type":"object","properties":{"datacenterId":{"description":"The datacenter to connect your VPN Gateway to.\n","type":"string"},"lanId":{"description":"The numeric LAN ID to connect your VPN Gateway to.","type":"string"},"ipv4CIDR":{"description":"A LAN IPv4 address in CIDR notation that will be assigned to the VPN Gateway.\nThis will be the private gateway address for LAN clients to route traffic over the VPN Gateway.\n__Note__: this should be within the subnet already assigned to the LAN\n","allOf":[{"$ref":"#/components/schemas/IPV4CIDR"}]},"ipv6CIDR":{"description":"A LAN IPv6 address in CIDR notation that will be assigned to the VPN Gateway.\nThis will be the private gateway address for LAN clients to route traffic over the VPN Gateway.\n__Note__: this should be within the subnet already assigned to the LAN\n","allOf":[{"$ref":"#/components/schemas/IPV6CIDR"}]}}},"IPPort":{"type":"integer","description":"IP port number","minimum":0,"maximum":65535},"Tier":{"type":"string","description":"Gateway performance options.  See product documentation for full details.\\\nOptions:\n- STANDARD\n- STANDARD_HA\n- ENHANCED\n- ENHANCED_HA\n- PREMIUM\n- PREMIUM_HA\n","default":"STANDARD"},"MaintenanceWindow":{"description":"A weekly 4 hour-long window, during which maintenance might occur.\n","properties":{"time":{"type":"string","description":"Start of the maintenance window in UTC time."},"dayOfTheWeek":{"$ref":"#/components/schemas/DayOfTheWeek"}},"required":["time","dayOfTheWeek"],"type":"object"},"DayOfTheWeek":{"description":"The name of the week day.","type":"string","enum":["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"]},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotFound":{"description":"### Not Found\nThe resource that was requested could not be found.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/wireguardgateways/{gatewayId}":{"get":{"operationId":"wireguardgatewaysFindById","summary":"Retrieve WireguardGateway","tags":["WireguardGateways"],"description":"Returns the WireguardGateway by ID.","parameters":[{"name":"gatewayId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the WireguardGateway."}],"responses":{"200":{"description":"Getting WireguardGateway was successful.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/WireguardGatewayRead"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"404":{"$ref":"#/components/responses/NotFound"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.ionos.com/cloud/api-reference/network-services/vpn-gateway/wireguard-gateways/retrieve-wireguardgateway.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
